unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, Grids;

type
  TForm1 = class(TForm)
    Button1: TButton;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses WbemScripting_TLB, activex;

procedure clearSG(sg:TStringGrid);
var i:integer;
begin
  for i:=1 to sg.ColCount do
    sg.Cols[i-1].Clear;
  sg.RowCount:=2;
  sg.Cols[0].Add('Name');
  sg.Cols[1].Add('DisplayName');
  sg.Cols[2].Add('ProcessId');
  sg.Cols[3].Add('State');
end;

procedure getServices(owner:TComponent; RemoteMachine,RemoteUser,RemotePassword:string; Services:TStringGrid; runningOnly:boolean);
var
  Locator: TSWbemLocator;
  SinkClasses: TSWbemSink;

  Service:   ISWbemServices;
  ObjectSet:  ISWbemObjectSet;
  SObject:    ISWbemObject;
  propSet :   ISWbemPropertySet;
  SProp:      ISWbemProperty;
  propEnum,
  Enum:       IEnumVariant;
  tempObj:    OleVariant;
  Count,
  Value:      Cardinal;

  sValue:     String;
  strQuery:   WideString;
  i:byte;
begin
  clearSG(Services);

  Locator:=TSWbemLocator.Create(owner);
  SinkClasses:=TSWbemSink.Create(owner);

  try
    SinkClasses.Cancel;

    if RemoteMachine='' then
      RemoteMachine:='.';// local machine
    Service := Locator.ConnectServer(RemoteMachine, 'root\CIMV2', RemoteUser, RemotePassword, '',
      '', 0, nil);

    ObjectSet := Service.InstancesOf('Win32_Service', wbemFlagReturnImmediately or wbemQueryFlagShallow, nil);

    Enum :=  (ObjectSet._NewEnum) as IEnumVariant;
    i:=0;
    while (Enum.Next(1, tempObj, Value) = S_OK) do
    begin
      SObject := IUnknown(tempObj) as SWBemObject;
      propSet := SObject.Properties_;
      propEnum := (propSet._NewEnum) as IEnumVariant;
      while (propEnum.Next(1, tempObj, Value) = S_OK) do
      begin
        SProp := IUnknown(tempObj) as SWBemProperty;
        if (SProp.Name<>'DisplayName') and (SProp.Name<>'Name')
          and (SProp.Name<>'ProcessId') and (SProp.Name<>'State') then
          continue;
        // now get the value of the property
        sValue := '';
        if VarIsNull(SProp.Get_Value) then
          sValue := '<empty>'
        else
        case SProp.CIMType of
          wbemCimtypeSint8, wbemCimtypeUint8, wbemCimtypeSint16, wbemCimtypeUint16,
          wbemCimtypeSint32, wbemCimtypeUint32, wbemCimtypeSint64:
            sValue := IntToStr(SProp.Get_Value);
          wbemCimtypeString, wbemCimtypeUint64:
          if VarIsArray(SProp.Get_Value) then
          begin
            if VarArrayHighBound(SProp.Get_Value, 1) > 0 then
              for Count := 1 to VarArrayHighBound(SProp.Get_Value, 1) do
                sValue := sValue + ' ' + SProp.Get_Value[Count];
          end
          else
            sValue :=  SProp.Get_Value;
          wbemCimtypeDatetime:sValue:=SProp.Get_Value//DateTimeToStr(SProp.Get_Value)
        else
            Exception.Create('Unknown type');
        end; {case}
        case i of
          0:Services.Cols[1].Add(sValue);
          1:Services.Cols[0].Add(sValue);
          2:Services.Cols[2].Add(sValue);
          3:Services.Cols[3].Add(sValue);
        end;
        i:=(i+1) mod 4;
        if i=0 then
        begin
          if runningOnly then
          begin
            if lowercase(sValue)<>'running' then
            begin
              for i:=1 to 4 do
                Services.Cols[i-1][Services.Cols[i-1].Count-1]:='';
              i:=0;
            end                             else
              services.RowCount:=services.RowCount+1;
          end            else
            services.RowCount:=services.RowCount+1;
        end;
      end; {while propEnum}
    end; {while Enum}

    strQuery := 'SELECT * FROM __InstanceCreationEvent within 5 WHERE TargetInstance' +
      ' ISA "Win32_Process"';
    Service.ExecNotificationQueryAsync(SinkClasses.DefaultInterface, strQuery, 'WQL', 0, nil, nil);
      strQuery := 'SELECT * FROM __InstanceDeletionEvent within 5 WHERE TargetInstance' +
      ' ISA "Win32_Process"';
    Service.ExecNotificationQueryAsync(SinkClasses.DefaultInterface, strQuery, 'WQL', 0, nil, nil);
  finally
  end; {try}
  Locator.Free;
  SinkClasses.Free;
  Service:=nil;// make sure the references are decreased
  ObjectSet:=nil;
  SObject:=nil;
  propSet:=nil;
  propEnum:=nil;
  SProp:=nil;
  enum:=nil;
  if services.RowCount>2 then
    services.RowCount:=services.RowCount-1;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  statusbar1.simpletext:='querying WMI....';
  getServices(self, '', '', '', StringGrid1,checkbox1.checked);
  statusbar1.simpletext:='done';
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  clearSg(StringGrid1);
end;

end.
